--- -/src/math/nextafter.c
+++ +/src/math/nextafter.c
@@ -3,20 +3,15 @@
 double nextafter(double x, double y)
 {
 	union {double f; uint64_t i;} ux={x}, uy={y};
-	uint64_t ax, ay;
 	int e;
 
 	if (isnan(x) || isnan(y))
 		return x + y;
-	if (ux.i == uy.i)
+	if (x == y)
 		return y;
-	ax = ux.i & -1ULL/2;
-	ay = uy.i & -1ULL/2;
-	if (ax == 0) {
-		if (ay == 0)
-			return y;
+	if (x == 0.0)
 		ux.i = (uy.i & 1ULL<<63) | 1;
-	} else if (ax > ay || ((ux.i ^ uy.i) & 1ULL<<63))
+	else if ((x < 0.0) == (x < y))
 		ux.i--;
 	else
 		ux.i++;
